<template>
  <div class="rui-dropdown"
       :class="cssClasses"
       @mouseenter="open"
       @mouseleave="close"
       @click="isOpen = !isOpen">
    <rui-button class="rui-dropdown__trigger">
      <slot name="caption"><span>{{ caption }}</span></slot>
      <template #right><rui-icon name="caret-down" class="rui-dropdown__trigger__arrow" /></template>
    </rui-button>
    <rui-menu v-show="isOpen" class="rui-dropdown__content" @click="close">
      <slot />
    </rui-menu>
  </div>
</template>

<script>
import RuiButton from '../Button/Button.vue'
import RuiMenu from '../Menu/Menu.vue'
import RuiIcon from '../Icon/Icon.vue'

/**
 * Dropdown menu.
 *
 * It wraps a `RuiMenu`, so give it `RuiMenuItem`s.
 *
 * @preset default {
 *                   "props": { "caption": "Click me" },
 *                   "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link</a>\n<button class=\"rui-menu-item\" href=\"#\">Button</a>" }
 *                 }
 */
export default {
  name: 'RuiDropdown',
  components: { RuiIcon, RuiButton, RuiMenu },
  props: {
    /** Trigger caption */
    caption: { required: false, type: String, default: null },
    /** Display trigger as block. Automatically applied when `selectLike` is used. */
    block: { required: false, type: Boolean, default: false },
    /** Align menu on the right */
    right: { required: false, type: Boolean, default: false },
    /** Display a wide menu */
    wide: { required: false, type: Boolean, default: false },
    /** Whether to display the trigger like a select input. Also activates `block` style */
    selectLike: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      // Handle this with JS so we still have the same behaviour on mobile:
      // once an item is clicked, there is no  way to close the menu
      isOpen: false,
    }
  },
  computed: {
    cssClasses () {
      return [
        (this.$props.block || this.$props.selectLike) && 'rui-dropdown--block',
        this.$props.right && 'rui-dropdown--right',
        this.$props.wide && 'rui-dropdown--wide',
        this.$props.selectLike && 'rui-dropdown--select-like',
      ]
    },
  },
  methods: {
    open () {
      if (this.selectLike) return
      this.isOpen = true
    },
    close () {
      if (this.selectLike) return
      this.isOpen = false
    },
  },
}
</script>
